#include "Ellipse.hpp"
#include <cmath>
Ellipse::Ellipse(Point center, double h1length, double h2length) : Shape(center), h1length(h1length), h2length(h2length) {}

Ellipse::~Ellipse(){
	std::cout << "Destruktor von Ellipse" << std::endl;
}

double Ellipse::area(){
	return PI*h1length*h2length;
}

double Ellipse::perimeter(){
	return PI*sqrt(2*(h1length*h1length + h2length*h2length));
}

bool Ellipse::inShape(Point p){
	return ( ( (p.x-center.x)*(p.x-center.x) / h1length*h1length) + ( (p.y-center.y)*(p.y-center.y) / h2length*h2length) ) <= 1;
}

void Ellipse::scale(double scaleFactor){
	h1length = h1length*scaleFactor;
	h2length = h2length*scaleFactor;
}
