#include "EquiTri.hpp"
#include <cmath>

EquiTri::EquiTri(Point center, double sidelength) : Shape(center), sidelength(sidelength) {}

EquiTri::~EquiTri(){
	std::cout << "Destruktor von EquiTri" << std::endl;
}

double EquiTri::area(){
	return sidelength*sidelength*sqrt(3)/4;
}

double EquiTri::perimeter(){
	return sidelength*3;
}

bool EquiTri::inShape(Point p){
	//höhe des dreiecks
	double height = sqrt( sidelength*sidelength - (sidelength/2)*(sidelength/2) );
	//3 eckpunte vom dreieck
	Point x_right(center.x+sidelength/2, center.y-height/3);
	Point x_left(center.x-sidelength/2, center.y-height/3);
	Point top(center.x, center.y+2*height/3);
	//2 vektoren von eckpunkten zur spitze
	Point vec_x_left_top (top.x - x_left.x, top.y - x_left.y);
	Point vec_x_right_top (top.x - x_right.x, top.y - x_right.y);
	
	//von der höhe her passend
	if(p.y >= x_left.y && p.y <= top.y) {
		//linke schräge
		while(x_left.y <= top.y){
			x_left.x += vec_x_left_top.x*0.0001;
			x_left.y += vec_x_left_top.y*0.0001;
			//"links-oberhalb" der schräge
			if(p.x < x_left.x && p.y > x_left.y){
				return false;
			}
		}
		//rechte schräge
		while(x_right.y <= top.y){
			x_right.x += vec_x_right_top.x*0.0001;
			x_right.y += vec_x_right_top.y*0.0001;
			//"rechts-oberhalb" der schräge
			if(p.x > x_right.x && p.y > x_right.y){
				return false;
			}
		}
		//innerhalb vom dreieck
		return true;
	}
	return false;
}

void EquiTri::scale(double scaleFactor){
	sidelength = sidelength*scaleFactor;
}

